//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll;
  vector<int>::iterator pos;

  INSERT_ELEMENTS(coll,1,9);

  PRINT_ELEMENTS(coll,":\n ");
  //   ,  3
  pos = find_if (coll.begin(), coll.end(),    // 
                 bind2nd(greater<int>(),3));  // 

  //  
  cout << ToRus("   ")
       << distance(coll.begin(),pos) + 1
       << ToRus(" - ,  3") << endl;

  //   ,  3
  pos = find_if (coll.begin(), coll.end(),
                 not1(bind2nd(modulus<int>(),3)));

  //  
  cout << ToRus("   ")
       << distance(coll.begin(),pos) + 1
       << ToRus(" - ,  3") << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------